// DLinkedList.cpp: implementation of the CDLinkedList class.
//
//////////////////////////////////////////////////////////////////////
#include <iostream.h>
#include <string.h>
#include "DLinkedList.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDLinkedList::CDLinkedList()
{
	head = NULL;
	tail = NULL;
}

CDLinkedList::~CDLinkedList()
{

}

int CDLinkedList::InsertFront(char *str)
{
	element *p;
	p = new element;
	memset(p->name,0,sizeof(p->name));
	strcpy(p->name, str);
	
	//尡 ٸ...
	if (head == NULL)
	{
		p->next = NULL;		
		tail = p;
	}
	else
	{
		p->next = head;
		head->prev = p;
	}
	
	p->prev = NULL;
	head = p;
		
	return 0;
}

int CDLinkedList::InsertTail(char *str)
{
	element *p;
	p = new element;
	memset(p->name,0,sizeof(p->name));
	strcpy(p->name, str);
	
	//尡 ٸ...
	if (tail == NULL)
	{		
		p->prev = NULL;	
		head = p;
	}
	else
	{
		p->prev = tail;	
		tail->next = p;
	}
	
	p->next = NULL;
	tail = p;
		
	return 0;
}

int CDLinkedList::DeleteFront(char *str)
{
	element *p;

	if (head == NULL)
		return -1;

	if (str != NULL)
		strcpy(str, head->name);

	if (head->next == NULL)
	{
		delete head;
		head = tail = NULL;
	}
	else
	{
		p = head->next;
		p->prev = NULL;
		delete head;
		head = p;
	}

	return 0;
}

int CDLinkedList::DeleteTail(char *str)
{
	element *p;

	if (tail == NULL)
		return -1;

	if (str != NULL)
		strcpy(str, tail->name);

	if (tail->prev == NULL)
	{
		delete tail;
		head = tail = NULL;
	}
	else
	{
		p = tail->prev;
		p->next = NULL;
		delete tail;
		tail = p;
	}

	return 0;
}

int CDLinkedList::PrintFront()
{
	element *p;

	if (head == NULL)
		return -1;

	p = head;

	while ( p != NULL)
	{
		cout << "]" << p->name << endl;
		p = p->next;
	}

	return 0;
}

int CDLinkedList::PrintTail()
{
	element *p;

	if (tail == NULL)
		return -1;

	p = tail;

	while ( p != NULL)
	{
		cout << "]" << p->name << endl;
		p = p->prev;
	}

	return 0;
}

void CDLinkedList::DeleteALL()
{
	while ( DeleteFront(NULL) == 0) ;
}
