// DLinkedList.h: interface for the CDLinkedList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DLINKEDLIST_H__64E483BF_77B6_40C4_ABB2_7A7602853E5C__INCLUDED_)
#define AFX_DLINKEDLIST_H__64E483BF_77B6_40C4_ABB2_7A7602853E5C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct element
{
	char name[20];
	element *next;
	element *prev;
};


class CDLinkedList  
{
public:
	element *head, *tail;
	
public:
	void DeleteALL();
	int PrintTail();
	int PrintFront();
	int DeleteTail(char *str);
	int DeleteFront(char *str);
	int InsertTail(char *str);
	int InsertFront(char *str);
	CDLinkedList();
	virtual ~CDLinkedList();
};

#endif // !defined(AFX_DLINKEDLIST_H__64E483BF_77B6_40C4_ABB2_7A7602853E5C__INCLUDED_)
